// 2d hDial v4
// = = = = = = = = = variables
lat=33.5;
lng=108.2;
ref=105;
// = = = = = = = = = 
st=2;    
en=23; 

translate([20,-30]) {
    color("black") {
        text(str("lat ",lat),6);
    }
}
translate([20,-40]) {
    color("black") {
        text(str("lng ",lng),6);
    }
}
translate([20,-50]) {
    color("black") {
        text(str("ref ",ref),6);
    }
}

translate([-80, 0]) {square(size=[160,2]);}
    
for (i=[st:1:en]) {
    hla=atan(sin(lat)*tan(15*i-(lng-ref)));
    sz=80;
    x=sz*sin(hla);       // or x=cos…
    y=sz*cos(hla);       // or y=sin…
    //                   // if so, change below code
    echo (lat,i,hla,"....",x,y);
    
    // AM
    // 0600 to 1200
    if ((i<=12) && (x<0) && (y>0)) {  
        //x=-x;    y=-y;
        color("black") {
            polygon([[0,0],[x,y],[.6,.6]]);
            translate([x, y]) {
                color("black"){
                    text(str("*",i),4);
                }
            }
        }
    }
    // 0600 or earlier
    if ((i<=6) && (x>0) && (y>0)) {  
        x=-x;    y=-y;
        color("green") {
            polygon([[0,0],[x,y],[.6,.6]]);
            translate([x, y]) {
                color("green"){
                    text(str("*",i),4);
                }
            }
        }
    }    
    
    // PM
    // 1800 or later
    if ((i>=18) && (x<0) && (y>0)) {  
        x=-x;    y=-y;
        color("blue") {
            polygon([[0,0],[x,y],[.6,.6]]);
            translate([x, y]) {
                color("blue"){
                    text(str("*",i),4);
                }
            }
        }
    }  
    // 1200 or later
    if ((i>12) && (i<=18) && (x>0) && (y>0)) {  
        color("red") {
            polygon([[0,0],[x,y],[.6,.6]]);
            translate([x, y]) {
                color("red"){
                    text(str("*",i),4);
                }
            }
        }
    }     
 
    // special case for i=12 and lng<=ref 
        if ((i==12) && (lng<=ref) ) {  
        color("blue") {
            polygon([[0,0],[x,y],[.6,.6]]);
            translate([x, y]) {
                color("blue"){
                    text(str("*",i),4);
                }
            }
        }
    }
    
    
    // special case for i=6 and lng=ref 
        if ((i==6) && (lng==ref) ) {  
        color("blue") {
            polygon([[0,0],[-x,y],[.6,.6]]);
            translate([-x, y]) {
                color("blue"){
                    text(str("*",i),4);
                }
            }
        }
    }

}   // END OF FOR loop

// *** END ***